THIS IS A TEST INSTANCE ONLY! REPOSITORIES CAN BE DELETED AT ANY TIME!

You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

config 28KB

  1. #!/bin/sh
  2. # Copyright 1998-2018 The OpenSSL Project Authors. All Rights Reserved.
  3. #
  4. # Licensed under the Apache License 2.0 (the "License"). You may not use
  5. # this file except in compliance with the License. You can obtain a copy
  6. # in the file LICENSE in the source distribution or at
  7. # https://www.openssl.org/source/license.html
  8. # OpenSSL config: determine the operating system and run ./Configure
  9. # Derived from minarch and GuessOS from Apache.
  10. #
  11. # Do "config -h" for usage information.
  12. SUFFIX=""
  13. DRYRUN="false"
  14. VERBOSE="false"
  15. EXE=""
  16. THERE=`dirname $0`
  17. # pick up any command line args to config
  18. for i
  19. do
  20. case "$i" in
  21. -d*) options=$options" --debug";;
  22. -t*) DRYRUN="true" VERBOSE="true";;
  23. -v*) VERBOSE="true";;
  24. -h*) DRYRUN="true"; cat <<EOF
  25. Usage: config [options]
  26. -d Build with debugging when possible.
  27. -t Test mode, do not run the Configure perl script.
  28. -v Verbose mode, show the exact Configure call that is being made.
  29. -h This help.
  30. Any other text will be passed to the Configure perl script.
  31. See INSTALL for instructions.
  32. EOF
  33. ;;
  34. *) i=`echo "$i" | sed -e "s|'|'\\\\\\''|g"`
  35. options="$options '$i'" ;;
  36. esac
  37. done
  38. # Environment that's being passed to Configure
  39. __CNF_CPPDEFINES=
  40. __CNF_CPPINCLUDES=
  41. __CNF_CPPFLAGS=
  42. __CNF_CFLAGS=
  43. __CNF_CXXFLAGS=
  44. __CNF_LDFLAGS=
  45. __CNF_LDLIBS=
  46. # First get uname entries that we use below
  47. [ "$MACHINE" ] || MACHINE=`(uname -m) 2>/dev/null` || MACHINE="unknown"
  48. [ "$RELEASE" ] || RELEASE=`(uname -r) 2>/dev/null` || RELEASE="unknown"
  49. [ "$SYSTEM" ] || SYSTEM=`(uname -s) 2>/dev/null` || SYSTEM="unknown"
  50. [ "$BUILD" ] || VERSION=`(uname -v) 2>/dev/null` || VERSION="unknown"
  51. # Now test for ISC and SCO, since it is has a braindamaged uname.
  52. #
  53. # We need to work around FreeBSD 1.1.5.1
  54. (
  55. XREL=`uname -X 2>/dev/null | grep "^Release" | awk '{print $3}'`
  56. if [ "x$XREL" != "x" ]; then
  57. if [ -f /etc/kconfig ]; then
  58. case "$XREL" in
  59. 4.0|4.1)
  60. echo "${MACHINE}-whatever-isc4"; exit 0
  61. ;;
  62. esac
  63. else
  64. case "$XREL" in
  65. 3.2v4.2)
  66. echo "whatever-whatever-sco3"; exit 0
  67. ;;
  68. 3.2v5.0*)
  69. echo "whatever-whatever-sco5"; exit 0
  70. ;;
  71. 4.2MP)
  72. case "x${VERSION}" in
  73. x2.0*) echo "whatever-whatever-unixware20"; exit 0 ;;
  74. x2.1*) echo "whatever-whatever-unixware21"; exit 0 ;;
  75. x2*) echo "whatever-whatever-unixware2"; exit 0 ;;
  76. esac
  77. ;;
  78. 4.2)
  79. echo "whatever-whatever-unixware1"; exit 0
  80. ;;
  81. 5*)
  82. case "x${VERSION}" in
  83. # We hardcode i586 in place of ${MACHINE} for the
  84. # following reason. The catch is that even though Pentium
  85. # is minimum requirement for platforms in question,
  86. # ${MACHINE} gets always assigned to i386. Now, problem
  87. # with i386 is that it makes ./config pass 386 to
  88. # ./Configure, which in turn makes make generate
  89. # inefficient SHA-1 (for this moment) code.
  90. x[678]*) echo "i586-sco-unixware7"; exit 0 ;;
  91. esac
  92. ;;
  93. esac
  94. fi
  95. fi
  96. # Now we simply scan though... In most cases, the SYSTEM info is enough
  97. #
  98. case "${SYSTEM}:${RELEASE}:${VERSION}:${MACHINE}" in
  99. A/UX:*)
  100. echo "m68k-apple-aux3"; exit 0
  101. ;;
  102. AIX:[3-9]:4:*)
  103. echo "${MACHINE}-ibm-aix"; exit 0
  104. ;;
  105. AIX:*:[5-9]:*)
  106. echo "${MACHINE}-ibm-aix"; exit 0
  107. ;;
  108. AIX:*)
  109. echo "${MACHINE}-ibm-aix3"; exit 0
  110. ;;
  111. HI-UX:*)
  112. echo "${MACHINE}-hi-hiux"; exit 0
  113. ;;
  114. HP-UX:*)
  115. HPUXVER=`echo ${RELEASE}|sed -e 's/[^.]*.[0B]*//'`
  116. case "$HPUXVER" in
  117. 1[0-9].*) # HPUX 10 and 11 targets are unified
  118. echo "${MACHINE}-hp-hpux1x"; exit 0
  119. ;;
  120. *)
  121. echo "${MACHINE}-hp-hpux"; exit 0
  122. ;;
  123. esac
  124. ;;
  125. IRIX:6.*)
  126. echo "mips3-sgi-irix"; exit 0
  127. ;;
  128. IRIX64:*)
  129. echo "mips4-sgi-irix64"; exit 0
  130. ;;
  131. Linux:[2-9].*)
  132. echo "${MACHINE}-whatever-linux2"; exit 0
  133. ;;
  134. Linux:1.*)
  135. echo "${MACHINE}-whatever-linux1"; exit 0
  136. ;;
  137. GNU*)
  138. echo "hurd-x86"; exit 0;
  139. ;;
  140. LynxOS:*)
  141. echo "${MACHINE}-lynx-lynxos"; exit 0
  142. ;;
  143. BSD/OS:4.*) # BSD/OS always says 386
  144. echo "i486-whatever-bsdi4"; exit 0
  145. ;;
  146. BSD/386:*:*:*486*|BSD/OS:*:*:*:*486*)
  147. case `/sbin/sysctl -n hw.model` in
  148. Pentium*)
  149. echo "i586-whatever-bsdi"; exit 0
  150. ;;
  151. *)
  152. echo "i386-whatever-bsdi"; exit 0
  153. ;;
  154. esac;
  155. ;;
  156. BSD/386:*|BSD/OS:*)
  157. echo "${MACHINE}-whatever-bsdi"; exit 0
  158. ;;
  159. FreeBSD:*:*:*386*)
  160. VERS=`echo ${RELEASE} | sed -e 's/[-(].*//'`
  161. MACH=`sysctl -n hw.model`
  162. ARCH='whatever'
  163. case ${MACH} in
  164. *386* ) MACH="i386" ;;
  165. *486* ) MACH="i486" ;;
  166. Pentium\ II*) MACH="i686" ;;
  167. Pentium* ) MACH="i586" ;;
  168. * ) MACH="$MACHINE" ;;
  169. esac
  170. case ${MACH} in
  171. i[0-9]86 ) ARCH="pc" ;;
  172. esac
  173. echo "${MACH}-${ARCH}-freebsd${VERS}"; exit 0
  174. ;;
  175. DragonFly:*)
  176. echo "${MACHINE}-whatever-dragonfly"; exit 0
  177. ;;
  178. FreeBSD:*)
  179. echo "${MACHINE}-whatever-freebsd"; exit 0
  180. ;;
  181. Haiku:*)
  182. echo "${MACHINE}-whatever-haiku"; exit 0
  183. ;;
  184. NetBSD:*:*:*386*)
  185. echo "`(/usr/sbin/sysctl -n hw.model || /sbin/sysctl -n hw.model) | sed 's,.*\(.\)86-class.*,i\186,'`-whatever-netbsd"; exit 0
  186. ;;
  187. NetBSD:*)
  188. echo "${MACHINE}-whatever-netbsd"; exit 0
  189. ;;
  190. OpenBSD:*)
  191. echo "${MACHINE}-whatever-openbsd"; exit 0
  192. ;;
  193. OpenUNIX:*)
  194. echo "${MACHINE}-unknown-OpenUNIX${VERSION}"; exit 0
  195. ;;
  196. OSF1:*:*:*alpha*)
  197. OSFMAJOR=`echo ${RELEASE}| sed -e 's/^V\([0-9]*\)\..*$/\1/'`
  198. case "$OSFMAJOR" in
  199. 4|5)
  200. echo "${MACHINE}-dec-tru64"; exit 0
  201. ;;
  202. 1|2|3)
  203. echo "${MACHINE}-dec-osf"; exit 0
  204. ;;
  205. *)
  206. echo "${MACHINE}-dec-osf"; exit 0
  207. ;;
  208. esac
  209. ;;
  210. Paragon*:*:*:*)
  211. echo "i860-intel-osf1"; exit 0
  212. ;;
  213. Rhapsody:*)
  214. echo "ppc-apple-rhapsody"; exit 0
  215. ;;
  216. Darwin:*)
  217. case "$MACHINE" in
  218. Power*)
  219. echo "ppc-apple-darwin${VERSION}"
  220. ;;
  221. x86_64)
  222. echo "x86_64-apple-darwin${VERSION}"
  223. ;;
  224. *)
  225. echo "i686-apple-darwin${VERSION}"
  226. ;;
  227. esac
  228. exit 0
  229. ;;
  230. SunOS:5.*)
  231. echo "${MACHINE}-whatever-solaris2"; exit 0
  232. ;;
  233. SunOS:*)
  234. echo "${MACHINE}-sun-sunos4"; exit 0
  235. ;;
  236. UNIX_System_V:4.*:*)
  237. echo "${MACHINE}-whatever-sysv4"; exit 0
  238. ;;
  239. VOS:*:*:i786)
  240. echo "i386-stratus-vos"; exit 0
  241. ;;
  242. VOS:*:*:*)
  243. echo "hppa1.1-stratus-vos"; exit 0
  244. ;;
  245. *:4*:R4*:m88k)
  246. echo "${MACHINE}-whatever-sysv4"; exit 0
  247. ;;
  248. DYNIX/ptx:4*:*)
  249. echo "${MACHINE}-whatever-sysv4"; exit 0
  250. ;;
  251. *:4.0:3.0:3[34]?? | *:4.0:3.0:3[34]??,*)
  252. echo "i486-ncr-sysv4"; exit 0
  253. ;;
  254. ULTRIX:*)
  255. echo "${MACHINE}-unknown-ultrix"; exit 0
  256. ;;
  257. POSIX-BC*)
  258. echo "${MACHINE}-siemens-sysv4"; exit 0 # Here, $MACHINE == "BS2000"
  259. ;;
  260. machten:*)
  261. echo "${MACHINE}-tenon-${SYSTEM}"; exit 0;
  262. ;;
  263. library:*)
  264. echo "${MACHINE}-ncr-sysv4"; exit 0
  265. ;;
  266. ConvexOS:*:11.0:*)
  267. echo "${MACHINE}-v11-${SYSTEM}"; exit 0;
  268. ;;
  269. # The following combinations are supported
  270. # MINGW64* on x86_64 => mingw64
  271. # MINGW32* on x86_64 => mingw
  272. # MINGW32* on i?86 => mingw
  273. #
  274. # MINGW64* on i?86 isn't expected to work...
  275. MINGW64*:*:*:x86_64)
  276. echo "${MACHINE}-whatever-mingw64"; exit 0;
  277. ;;
  278. MINGW*)
  279. echo "${MACHINE}-whatever-mingw"; exit 0;
  280. ;;
  281. CYGWIN*)
  282. echo "${MACHINE}-pc-cygwin"; exit 0
  283. ;;
  284. vxworks*)
  285. echo "${MACHINE}-whatever-vxworks"; exit 0;
  286. ;;
  287. esac
  288. #
  289. # Ugg. These are all we can determine by what we know about
  290. # the output of uname. Be more creative:
  291. #
  292. # Do the Apollo stuff first. Here, we just simply assume
  293. # that the existence of the /usr/apollo directory is proof
  294. # enough
  295. if [ -d /usr/apollo ]; then
  296. echo "whatever-apollo-whatever"
  297. exit 0
  298. fi
  299. # At this point we gone through all the one's
  300. # we know of: Punt
  301. echo "${MACHINE}-whatever-${SYSTEM}"
  302. exit 0
  303. ) 2>/dev/null | (
  304. # ---------------------------------------------------------------------------
  305. # this is where the translation occurs into SSLeay terms
  306. # ---------------------------------------------------------------------------
  307. # Only set CC if not supplied already
  308. if [ -z "$CROSS_COMPILE$CC" ]; then
  309. GCCVER=`sh -c "gcc -dumpversion" 2>/dev/null`
  310. if [ "$GCCVER" != "" ]; then
  311. # then strip off whatever prefix egcs prepends the number with...
  312. # Hopefully, this will work for any future prefixes as well.
  313. GCCVER=`echo $GCCVER | LC_ALL=C sed 's/^[a-zA-Z]*\-//'`
  314. # Since gcc 3.1 gcc --version behaviour has changed. gcc -dumpversion
  315. # does give us what we want though, so we use that. We just just the
  316. # major and minor version numbers.
  317. # peak single digit before and after first dot, e.g. 2.95.1 gives 29
  318. GCCVER=`echo $GCCVER | sed 's/\([0-9]\)\.\([0-9]\).*/\1\2/'`
  319. CC=gcc
  320. else
  321. CC=cc
  322. fi
  323. fi
  324. GCCVER=${GCCVER:-0}
  325. if [ "$SYSTEM" = "HP-UX" ];then
  326. # By default gcc is a ILP32 compiler (with long long == 64).
  327. GCC_BITS="32"
  328. if [ $GCCVER -ge 30 ]; then
  329. # PA64 support only came in with gcc 3.0.x.
  330. # We check if the preprocessor symbol __LP64__ is defined...
  331. if echo "__LP64__" | gcc -v -E -x c - 2>/dev/null | grep "^__LP64__" 2>&1 > /dev/null; then
  332. : # __LP64__ has slipped through, it therefore is not defined
  333. else
  334. GCC_BITS="64"
  335. fi
  336. fi
  337. fi
  338. if [ "$SYSTEM" = "SunOS" ]; then
  339. if [ $GCCVER -ge 30 ]; then
  340. # 64-bit ABI isn't officially supported in gcc 3.0, but it appears
  341. # to be working, at the very least 'make test' passes...
  342. if gcc -v -E -x c /dev/null 2>&1 | grep __arch64__ > /dev/null; then
  343. GCC_ARCH="-m64"
  344. else
  345. GCC_ARCH="-m32"
  346. fi
  347. fi
  348. # check for WorkShop C, expected output is "cc: blah-blah C x.x"
  349. CCVER=`(cc -V 2>&1) 2>/dev/null | \
  350. egrep -e '^cc: .* C [0-9]\.[0-9]' | \
  351. sed 's/.* C \([0-9]\)\.\([0-9]\).*/\1\2/'`
  352. CCVER=${CCVER:-0}
  353. if [ $MACHINE != i86pc -a $CCVER -gt 40 ]; then
  354. CC=cc # overrides gcc!!!
  355. if [ $CCVER -eq 50 ]; then
  356. echo "WARNING! Detected WorkShop C 5.0. Do make sure you have"
  357. echo " patch #107357-01 or later applied."
  358. sleep 5
  359. fi
  360. fi
  361. fi
  362. if [ "${SYSTEM}" = "AIX" ]; then # favor vendor cc over gcc
  363. (cc) 2>&1 | grep -iv "not found" > /dev/null && CC=cc
  364. fi
  365. CCVER=${CCVER:-0}
  366. # read the output of the embedded GuessOS
  367. read GUESSOS
  368. echo Operating system: $GUESSOS
  369. # now map the output into SSLeay terms ... really should hack into the
  370. # script above so we end up with values in vars but that would take
  371. # more time that I want to waste at the moment
  372. case "$GUESSOS" in
  373. uClinux*64*)
  374. OUT=uClinux-dist64
  375. ;;
  376. uClinux*)
  377. OUT=uClinux-dist
  378. ;;
  379. mips3-sgi-irix)
  380. OUT="irix-mips3-$CC"
  381. ;;
  382. mips4-sgi-irix64)
  383. echo "WARNING! If you wish to build 64-bit library, then you have to"
  384. echo " invoke '$THERE/Configure irix64-mips4-$CC' *manually*."
  385. if [ "$DRYRUN" = "false" -a -t 1 ]; then
  386. echo " You have about 5 seconds to press Ctrl-C to abort."
  387. (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
  388. fi
  389. OUT="irix-mips3-$CC"
  390. ;;
  391. ppc-apple-rhapsody) OUT="rhapsody-ppc-cc" ;;
  392. ppc-apple-darwin*)
  393. ISA64=`(sysctl -n hw.optional.64bitops) 2>/dev/null`
  394. if [ "$ISA64" = "1" -a -z "$KERNEL_BITS" ]; then
  395. echo "WARNING! If you wish to build 64-bit library, then you have to"
  396. echo " invoke '$THERE/Configure darwin64-ppc-cc' *manually*."
  397. if [ "$DRYRUN" = "false" -a -t 1 ]; then
  398. echo " You have about 5 seconds to press Ctrl-C to abort."
  399. (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
  400. fi
  401. fi
  402. if [ "$ISA64" = "1" -a "$KERNEL_BITS" = "64" ]; then
  403. OUT="darwin64-ppc-cc"
  404. else
  405. OUT="darwin-ppc-cc"
  406. fi ;;
  407. i?86-apple-darwin*)
  408. ISA64=`(sysctl -n hw.optional.x86_64) 2>/dev/null`
  409. if [ "$ISA64" = "1" -a -z "$KERNEL_BITS" ]; then
  410. echo "WARNING! If you wish to build 64-bit library, then you have to"
  411. echo " invoke 'KERNEL_BITS=64 $THERE/config $options'."
  412. if [ "$DRYRUN" = "false" -a -t 1 ]; then
  413. echo " You have about 5 seconds to press Ctrl-C to abort."
  414. (trap "stty `stty -g`; exit 1" 2; stty -icanon min 0 time 50; read waste; exit 0) <&1 || exit
  415. fi
  416. fi
  417. if [ "$ISA64" = "1" -a "$KERNEL_BITS" = "64" ]; then
  418. OUT="darwin64-x86_64-cc"
  419. else
  420. OUT="darwin-i386-cc"
  421. fi ;;
  422. x86_64-apple-darwin*)
  423. if [ "$KERNEL_BITS" = "32" ]; then
  424. OUT="darwin-i386-cc"
  425. else
  426. OUT="darwin64-x86_64-cc"
  427. fi ;;
  428. armv6+7-*-iphoneos)
  429. __CNF_CFLAGS="$__CNF_CFLAGS -arch armv6 -arch armv7"
  430. __CNF_CXXFLAGS="$__CNF_CXXFLAGS -arch armv6 -arch armv7"
  431. OUT="iphoneos-cross" ;;
  432. *-*-iphoneos)
  433. __CNF_CFLAGS="$__CNF_CFLAGS -arch ${MACHINE}"
  434. __CNF_CXXFLAGS="$__CNF_CXXFLAGS -arch ${MACHINE}"
  435. OUT="iphoneos-cross" ;;
  436. arm64-*-iphoneos|*-*-ios64)
  437. OUT="ios64-cross" ;;
  438. alpha-*-linux2)
  439. ISA=`awk '/cpu model/{print$4;exit(0);}' /proc/cpuinfo`
  440. case ${ISA:-generic} in
  441. *[678]) OUT="linux-alpha+bwx-$CC" ;;
  442. *) OUT="linux-alpha-$CC" ;;
  443. esac
  444. if [ "$CC" = "gcc" ]; then
  445. case ${ISA:-generic} in
  446. EV5|EV45) __CNF_CFLAGS="$__CNF_CFLAGS -mcpu=ev5"
  447. __CNF_CXXFLAGS="$__CNF_CFLAGS -mcpu=ev5";;
  448. EV56|PCA56) __CNF_CFLAGS="$__CNF_CFLAGS -mcpu=ev56"
  449. __CNF_CXXFLAGS="$__CNF_CXXFLAGS -mcpu=ev56";;
  450. *) __CNF_CFLAGS="$__CNF_CFLAGS -mcpu=ev6"
  451. __CNF_CXXFLAGS="$__CNF_CXXFLAGS -mcpu=ev6";;
  452. esac
  453. fi
  454. ;;
  455. ppc64-*-linux2)
  456. if [ -z "$KERNEL_BITS" ]; then
  457. echo "WARNING! If you wish to build 64-bit library, then you have to"
  458. echo " invoke '$THERE/Configure linux-ppc64' *manually*."
  459. if [ "$DRYRUN" = "false" -a -t 1 ]; then
  460. echo " You have about 5 seconds to press Ctrl-C to abort."
  461. (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
  462. fi
  463. fi
  464. if [ "$KERNEL_BITS" = "64" ]; then
  465. OUT="linux-ppc64"
  466. else
  467. OUT="linux-ppc"
  468. if (echo "__LP64__" | gcc -E -x c - 2>/dev/null | grep "^__LP64__" 2>&1 > /dev/null); then
  469. :;
  470. else
  471. __CNF_CFLAGS="$__CNF_CFLAGS -m32"
  472. __CNF_CXXFLAGS="$__CNF_CXXFLAGS -m32"
  473. fi
  474. fi
  475. ;;
  476. ppc64le-*-linux2) OUT="linux-ppc64le" ;;
  477. ppc-*-linux2) OUT="linux-ppc" ;;
  478. mips64*-*-linux2)
  479. echo "WARNING! If you wish to build 64-bit library, then you have to"
  480. echo " invoke '$THERE/Configure linux64-mips64' *manually*."
  481. if [ "$DRYRUN" = "false" -a -t 1 ]; then
  482. echo " You have about 5 seconds to press Ctrl-C to abort."
  483. (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
  484. fi
  485. OUT="linux-mips64"
  486. ;;
  487. mips*-*-linux2) OUT="linux-mips32" ;;
  488. ppc60x-*-vxworks*) OUT="vxworks-ppc60x" ;;
  489. ppcgen-*-vxworks*) OUT="vxworks-ppcgen" ;;
  490. pentium-*-vxworks*) OUT="vxworks-pentium" ;;
  491. simlinux-*-vxworks*) OUT="vxworks-simlinux" ;;
  492. mips-*-vxworks*) OUT="vxworks-mips";;
  493. ia64-*-linux?) OUT="linux-ia64" ;;
  494. sparc64-*-linux2)
  495. echo "WARNING! If you *know* that your GNU C supports 64-bit/V9 ABI"
  496. echo " and wish to build 64-bit library, then you have to"
  497. echo " invoke '$THERE/Configure linux64-sparcv9' *manually*."
  498. if [ "$DRYRUN" = "false" -a -t 1 ]; then
  499. echo " You have about 5 seconds to press Ctrl-C to abort."
  500. (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
  501. fi
  502. OUT="linux-sparcv9" ;;
  503. sparc-*-linux2)
  504. KARCH=`awk '/^type/{print$3;exit(0);}' /proc/cpuinfo`
  505. case ${KARCH:-sun4} in
  506. sun4u*) OUT="linux-sparcv9" ;;
  507. sun4m) OUT="linux-sparcv8" ;;
  508. sun4d) OUT="linux-sparcv8" ;;
  509. *) OUT="linux-generic32";
  510. __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DB_ENDIAN" ;;
  511. esac ;;
  512. parisc*-*-linux2)
  513. # 64-bit builds under parisc64 linux are not supported and
  514. # compiler is expected to generate 32-bit objects...
  515. CPUARCH=`awk '/cpu family/{print substr($5,1,3); exit(0);}' /proc/cpuinfo`
  516. CPUSCHEDULE=`awk '/^cpu.[ ]*: PA/{print substr($3,3); exit(0);}' /proc/cpuinfo`
  517. # ??TODO ?? Model transformations
  518. # 0. CPU Architecture for the 1.1 processor has letter suffixes. We strip that off
  519. # assuming no further arch. identification will ever be used by GCC.
  520. # 1. I'm most concerned about whether is a 7300LC is closer to a 7100 versus a 7100LC.
  521. # 2. The variant 64-bit processors cause concern should GCC support explicit schedulers
  522. # for these chips in the future.
  523. # PA7300LC -> 7100LC (1.1)
  524. # PA8200 -> 8000 (2.0)
  525. # PA8500 -> 8000 (2.0)
  526. # PA8600 -> 8000 (2.0)
  527. CPUSCHEDULE=`echo $CPUSCHEDULE|sed -e 's/7300LC/7100LC/' -e 's/8.00/8000/'`
  528. # Finish Model transformations
  529. __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DB_ENDIAN"
  530. __CNF_CFLAGS="$__CNF_CFLAGS -mschedule=$CPUSCHEDULE -march=$CPUARCH"
  531. __CNF_CXXFLAGS="$__CNF_CXXFLAGS -mschedule=$CPUSCHEDULE -march=$CPUARCH"
  532. OUT="linux-generic32" ;;
  533. armv[1-3]*-*-linux2) OUT="linux-generic32" ;;
  534. armv[7-9]*-*-linux2) OUT="linux-armv4"
  535. __CNF_CFLAGS="$__CNF_CFLAGS -march=armv7-a"
  536. __CNF_CXXFLAGS="$__CNF_CXXFLAGS -march=armv7-a"
  537. ;;
  538. arm*-*-linux2) OUT="linux-armv4" ;;
  539. aarch64-*-linux2) OUT="linux-aarch64" ;;
  540. sh*b-*-linux2) OUT="linux-generic32";
  541. __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DB_ENDIAN" ;;
  542. sh*-*-linux2) OUT="linux-generic32";
  543. __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DL_ENDIAN" ;;
  544. m68k*-*-linux2) OUT="linux-generic32";
  545. __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DB_ENDIAN" ;;
  546. s390-*-linux2) OUT="linux-generic32";
  547. __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DB_ENDIAN" ;;
  548. s390x-*-linux2)
  549. # To be uncommented when glibc bug is fixed, see Configure...
  550. #if egrep -e '^features.* highgprs' /proc/cpuinfo >/dev/null ; then
  551. # echo "WARNING! If you wish to build \"highgprs\" 32-bit library, then you"
  552. # echo " have to invoke './Configure linux32-s390x' *manually*."
  553. # if [ "$DRYRUN" = "false" -a -t -1 ]; then
  554. # echo " You have about 5 seconds to press Ctrl-C to abort."
  555. # (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
  556. # fi
  557. #fi
  558. OUT="linux64-s390x"
  559. ;;
  560. x86_64-*-linux?)
  561. if $CC -dM -E -x c /dev/null 2>&1 | grep -q ILP32 > /dev/null; then
  562. OUT="linux-x32"
  563. else
  564. OUT="linux-x86_64"
  565. fi ;;
  566. *86-*-linux2)
  567. # On machines where the compiler understands -m32, prefer a
  568. # config target that uses it
  569. if $CC -m32 -E -x c /dev/null > /dev/null 2>&1; then
  570. OUT="linux-x86"
  571. else
  572. OUT="linux-elf"
  573. fi ;;
  574. *86-*-linux1) OUT="linux-aout" ;;
  575. *-*-linux?) OUT="linux-generic32" ;;
  576. sun4[uv]*-*-solaris2)
  577. OUT="solaris-sparcv9-$CC"
  578. ISA64=`(isainfo) 2>/dev/null | grep sparcv9`
  579. if [ "$ISA64" != "" -a "$KERNEL_BITS" = "" ]; then
  580. if [ "$CC" = "cc" -a $CCVER -ge 50 ]; then
  581. echo "WARNING! If you wish to build 64-bit library, then you have to"
  582. echo " invoke '$THERE/Configure solaris64-sparcv9-cc' *manually*."
  583. if [ "$DRYRUN" = "false" -a -t 1 ]; then
  584. echo " You have about 5 seconds to press Ctrl-C to abort."
  585. (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
  586. fi
  587. elif [ "$CC" = "gcc" -a "$GCC_ARCH" = "-m64" ]; then
  588. # $GCC_ARCH denotes default ABI chosen by compiler driver
  589. # (first one found on the $PATH). I assume that user
  590. # expects certain consistency with the rest of his builds
  591. # and therefore switch over to 64-bit. <appro>
  592. OUT="solaris64-sparcv9-gcc"
  593. echo "WARNING! If you wish to build 32-bit library, then you have to"
  594. echo " invoke '$THERE/Configure solaris-sparcv9-gcc' *manually*."
  595. if [ "$DRYRUN" = "false" -a -t 1 ]; then
  596. echo " You have about 5 seconds to press Ctrl-C to abort."
  597. (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
  598. fi
  599. elif [ "$GCC_ARCH" = "-m32" ]; then
  600. echo "NOTICE! If you *know* that your GNU C supports 64-bit/V9 ABI"
  601. echo " and wish to build 64-bit library, then you have to"
  602. echo " invoke '$THERE/Configure solaris64-sparcv9-gcc' *manually*."
  603. if [ "$DRYRUN" = "false" -a -t 1 ]; then
  604. echo " You have about 5 seconds to press Ctrl-C to abort."
  605. (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
  606. fi
  607. fi
  608. fi
  609. if [ "$ISA64" != "" -a "$KERNEL_BITS" = "64" ]; then
  610. OUT="solaris64-sparcv9-$CC"
  611. fi
  612. ;;
  613. sun4m-*-solaris2) OUT="solaris-sparcv8-$CC" ;;
  614. sun4d-*-solaris2) OUT="solaris-sparcv8-$CC" ;;
  615. sun4*-*-solaris2) OUT="solaris-sparcv7-$CC" ;;
  616. *86*-*-solaris2)
  617. ISA64=`(isainfo) 2>/dev/null | grep amd64`
  618. if [ "$ISA64" != "" -a ${KERNEL_BITS:-64} -eq 64 ]; then
  619. OUT="solaris64-x86_64-$CC"
  620. else
  621. OUT="solaris-x86-$CC"
  622. if [ `uname -r | sed -e 's/5\.//'` -lt 10 ]; then
  623. options="$options no-sse2"
  624. fi
  625. fi
  626. ;;
  627. *-*-sunos4) OUT="sunos-$CC" ;;
  628. *86*-*-bsdi4) OUT="BSD-x86-elf"; options="$options no-sse2";
  629. __CNF_LDFLAGS="$__CNF_LDFLAGS -ldl" ;;
  630. alpha*-*-*bsd*) OUT="BSD-generic64";
  631. __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DL_ENDIAN" ;;
  632. powerpc64-*-*bsd*) OUT="BSD-generic64";
  633. __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DB_ENDIAN" ;;
  634. sparc64-*-*bsd*) OUT="BSD-sparc64" ;;
  635. ia64-*-*bsd*) OUT="BSD-ia64" ;;
  636. x86_64-*-dragonfly*) OUT="BSD-x86_64" ;;
  637. amd64-*-*bsd*) OUT="BSD-x86_64" ;;
  638. *86*-*-*bsd*) # mimic ld behaviour when it's looking for libc...
  639. if [ -L /usr/lib/libc.so ]; then # [Free|Net]BSD
  640. libc=/usr/lib/libc.so
  641. else # OpenBSD
  642. # ld searches for highest libc.so.* and so do we
  643. libc=`(ls /usr/lib/libc.so.* /lib/libc.so.* | tail -1) 2>/dev/null`
  644. fi
  645. case "`(file -L $libc) 2>/dev/null`" in
  646. *ELF*) OUT="BSD-x86-elf" ;;
  647. *) OUT="BSD-x86"; options="$options no-sse2" ;;
  648. esac ;;
  649. *-*-*bsd*) OUT="BSD-generic32" ;;
  650. x86_64-*-haiku) OUT="haiku-x86_64" ;;
  651. *-*-haiku) OUT="haiku-x86" ;;
  652. *-*-osf) OUT="osf1-alpha-cc" ;;
  653. *-*-tru64) OUT="tru64-alpha-cc" ;;
  654. *-*-[Uu]nix[Ww]are7)
  655. if [ "$CC" = "gcc" ]; then
  656. OUT="unixware-7-gcc" ; options="$options no-sse2"
  657. else
  658. OUT="unixware-7" ; options="$options no-sse2"
  659. __CNF_CPPFLAGS="$__CNF_CPPFLAGS -D__i386__"
  660. fi
  661. ;;
  662. *-*-[Uu]nix[Ww]are20*) OUT="unixware-2.0"; options="$options no-sse2 no-sha512" ;;
  663. *-*-[Uu]nix[Ww]are21*) OUT="unixware-2.1"; options="$options no-sse2 no-sha512" ;;
  664. *-*-vos)
  665. options="$options no-threads no-shared no-asm no-dso"
  666. EXE=".pm"
  667. OUT="vos-$CC" ;;
  668. BS2000-siemens-sysv4) OUT="BS2000-OSD" ;;
  669. *-hpux1*)
  670. if [ $CC = "gcc" -a $GCC_BITS = "64" ]; then
  671. OUT="hpux64-parisc2-gcc"
  672. fi
  673. [ "$KERNEL_BITS" ] || KERNEL_BITS=`(getconf KERNEL_BITS) 2>/dev/null`
  674. KERNEL_BITS=${KERNEL_BITS:-32}
  675. CPU_VERSION=`(getconf CPU_VERSION) 2>/dev/null`
  676. CPU_VERSION=${CPU_VERSION:-0}
  677. # See <sys/unistd.h> for further info on CPU_VERSION.
  678. if [ $CPU_VERSION -ge 768 ]; then # IA-64 CPU
  679. if [ $KERNEL_BITS -eq 64 -a "$CC" = "cc" ]; then
  680. OUT="hpux64-ia64-cc"
  681. else
  682. OUT="hpux-ia64-cc"
  683. fi
  684. elif [ $CPU_VERSION -ge 532 ]; then # PA-RISC 2.x CPU
  685. # PA-RISC 2.0 is no longer supported as separate 32-bit
  686. # target. This is compensated for by run-time detection
  687. # in most critical assembly modules and taking advantage
  688. # of 2.0 architecture in PA-RISC 1.1 build.
  689. OUT=${OUT:-"hpux-parisc1_1-${CC}"}
  690. if [ $KERNEL_BITS -eq 64 -a "$CC" = "cc" ]; then
  691. echo "WARNING! If you wish to build 64-bit library then you have to"
  692. echo " invoke '$THERE/Configure hpux64-parisc2-cc' *manually*."
  693. if [ "$DRYRUN" = "false" -a -t 1 ]; then
  694. echo " You have about 5 seconds to press Ctrl-C to abort."
  695. (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
  696. fi
  697. fi
  698. elif [ $CPU_VERSION -ge 528 ]; then # PA-RISC 1.1+ CPU
  699. OUT="hpux-parisc1_1-${CC}"
  700. elif [ $CPU_VERSION -ge 523 ]; then # PA-RISC 1.0 CPU
  701. OUT="hpux-parisc-${CC}"
  702. else # Motorola(?) CPU
  703. OUT="hpux-$CC"
  704. fi
  705. __CNF_CPPFLAGS="$__CNF_CPPFLAGS -D_REENTRANT" ;;
  706. *-hpux) OUT="hpux-parisc-$CC" ;;
  707. *-aix)
  708. [ "$KERNEL_BITS" ] || KERNEL_BITS=`(getconf KERNEL_BITMODE) 2>/dev/null`
  709. KERNEL_BITS=${KERNEL_BITS:-32}
  710. OBJECT_MODE=${OBJECT_MODE:-32}
  711. if [ "$CC" = "gcc" ]; then
  712. OUT="aix-gcc"
  713. if [ $OBJECT_MODE -eq 64 ]; then
  714. echo 'Your $OBJECT_MODE was found to be set to 64'
  715. OUT="aix64-gcc"
  716. fi
  717. elif [ $OBJECT_MODE -eq 64 ]; then
  718. echo 'Your $OBJECT_MODE was found to be set to 64'
  719. OUT="aix64-cc"
  720. else
  721. OUT="aix-cc"
  722. if [ $KERNEL_BITS -eq 64 ]; then
  723. echo "WARNING! If you wish to build 64-bit kit, then you have to"
  724. echo " invoke '$THERE/Configure aix64-cc' *manually*."
  725. if [ "$DRYRUN" = "false" -a -t 1 ]; then
  726. echo " You have ~5 seconds to press Ctrl-C to abort."
  727. (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
  728. fi
  729. fi
  730. fi
  731. if (lsattr -E -O -l `lsdev -c processor|awk '{print$1;exit}'` | grep -i powerpc) >/dev/null 2>&1; then
  732. : # this applies even to Power3 and later, as they return PowerPC_POWER[345]
  733. else
  734. options="$options no-asm"
  735. fi
  736. ;;
  737. # these are all covered by the catchall below
  738. i[3456]86-*-cygwin) OUT="Cygwin-x86" ;;
  739. *-*-cygwin) OUT="Cygwin-${MACHINE}" ;;
  740. x86-*-android|i?86-*-android) OUT="android-x86" ;;
  741. armv[7-9]*-*-android)
  742. OUT="android-armeabi"
  743. __CNF_CFLAGS="$__CNF_CFLAGS -march=armv7-a"
  744. __CNF_CXXFLAGS="$__CNF_CXXFLAGS -march=armv7-a";;
  745. arm*-*-android) OUT="android-armeabi" ;;
  746. *) OUT=`echo $GUESSOS | awk -F- '{print $3}'`;;
  747. esac
  748. # NB: This atalla support has been superseded by the ENGINE support
  749. # That contains its own header and definitions anyway. Support can
  750. # be enabled or disabled on any supported platform without external
  751. # headers, eg. by adding the "hw-atalla" switch to ./config or
  752. # perl Configure
  753. #
  754. # See whether we can compile Atalla support
  755. #if [ -f /usr/include/atasi.h ]
  756. #then
  757. # __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DATALLA"
  758. #fi
  759. if [ -n "$CONFIG_OPTIONS" ]; then
  760. options="$options $CONFIG_OPTIONS"
  761. fi
  762. # gcc < 2.8 does not support -march=ultrasparc
  763. if [ "$OUT" = solaris-sparcv9-gcc -a $GCCVER -lt 28 ]
  764. then
  765. echo "WARNING! Falling down to 'solaris-sparcv8-gcc'."
  766. echo " Upgrade to gcc-2.8 or later."
  767. sleep 5
  768. OUT=solaris-sparcv8-gcc
  769. fi
  770. if [ "$OUT" = "linux-sparcv9" -a $GCCVER -lt 28 ]
  771. then
  772. echo "WARNING! Falling down to 'linux-sparcv8'."
  773. echo " Upgrade to gcc-2.8 or later."
  774. sleep 5
  775. OUT=linux-sparcv8
  776. fi
  777. case "$GUESSOS" in
  778. i386-*) options="$options 386" ;;
  779. esac
  780. for i in aes aria bf camellia cast des dh dsa ec hmac idea md2 md5 mdc2 rc2 rc4 rc5 ripemd rsa seed sha sm2 sm3 sm4
  781. do
  782. if [ ! -d $THERE/crypto/$i ]
  783. then
  784. options="$options no-$i"
  785. fi
  786. done
  787. if [ -z "$OUT" ]; then
  788. OUT="$CC"
  789. fi
  790. if [ ".$PERL" = . ] ; then
  791. for i in . `echo $PATH | sed 's/:/ /g'`; do
  792. if [ -f "$i/perl5$EXE" ] ; then
  793. PERL="$i/perl5$EXE"
  794. break;
  795. fi;
  796. done
  797. fi
  798. if [ ".$PERL" = . ] ; then
  799. for i in . `echo $PATH | sed 's/:/ /g'`; do
  800. if [ -f "$i/perl$EXE" ] ; then
  801. if "$i/perl$EXE" -e 'exit($]<5.0)'; then
  802. PERL="$i/perl$EXE"
  803. break;
  804. fi;
  805. fi;
  806. done
  807. fi
  808. if [ ".$PERL" = . ] ; then
  809. echo "You need Perl 5."
  810. exit 1
  811. fi
  812. # run Configure to check to see if we need to specify the
  813. # compiler for the platform ... in which case we add it on
  814. # the end ... otherwise we leave it off
  815. $PERL $THERE/Configure LIST | grep "$OUT-$CC" > /dev/null
  816. if [ $? = "0" ]; then
  817. OUT="$OUT-$CC"
  818. fi
  819. OUT="$OUT"
  820. $PERL $THERE/Configure LIST | grep "$OUT" > /dev/null
  821. if [ $? = "0" ]; then
  822. if [ "$VERBOSE" = "true" ]; then
  823. echo /usr/bin/env \
  824. __CNF_CPPDEFINES="'$__CNF_CPPDEFINES'" \
  825. __CNF_CPPINCLUDES="'$__CNF_CPPINCLUDES'" \
  826. __CNF_CPPFLAGS="'$__CNF_CPPFLAGS'" \
  827. __CNF_CFLAGS="'$__CNF_CFLAGS'" \
  828. __CNF_CXXFLAGS="'$__CNF_CXXFLAGS'" \
  829. __CNF_LDFLAGS="'$__CNF_LDFLAGS'" \
  830. __CNF_LDLIBS="'$__CNF_LDLIBS'" \
  831. $PERL $THERE/Configure $OUT $options
  832. fi
  833. if [ "$DRYRUN" = "false" ]; then
  834. # eval to make sure quoted options, possibly with spaces inside,
  835. # are treated right
  836. eval /usr/bin/env \
  837. __CNF_CPPDEFINES="'$__CNF_CPPDEFINES'" \
  838. __CNF_CPPINCLUDES="'$__CNF_CPPINCLUDES'" \
  839. __CNF_CPPFLAGS="'$__CNF_CPPFLAGS'" \
  840. __CNF_CFLAGS="'$__CNF_CFLAGS'" \
  841. __CNF_CXXFLAGS="'$__CNF_CXXFLAGS'" \
  842. __CNF_LDFLAGS="'$__CNF_LDFLAGS'" \
  843. __CNF_LDLIBS="'$__CNF_LDLIBS'" \
  844. $PERL $THERE/Configure $OUT $options
  845. fi
  846. else
  847. echo "This system ($OUT) is not supported. See file INSTALL for details."
  848. exit 1
  849. fi
  850. if [ "$OUT" = "darwin64-x86_64-cc" ]; then
  851. echo "WARNING! If you wish to build 32-bit libraries, then you have to"
  852. echo " invoke 'KERNEL_BITS=32 $THERE/config $options'."
  853. fi
  854. )